<script lang="ts">
  import { page } from '$app/stores';
  import Accordion from '@svelte-ui/accordion/Accordion.svelte';
  import { onDestroy } from 'svelte';
  import DropDownArrow from '~/components/select/DropDownArrow.svelte';
  import { footerLinks } from '~/constants/footer-links.js';

  let isHome = true;

  const { resources, supports, terms } = footerLinks.sub;
  const isOpened = [true, true, true];

  const unsubscribe = page.subscribe((data) => {
    isHome = data.route.id === '/';
    isOpened.forEach((bool, idx) => {
      isOpened[idx] = isHome;
    });
  });

  onDestroy(() => {
    unsubscribe();
  });

  const onToggle = (idx: number, data: Record<string, string>) => {
    isOpened.forEach(() => {
      isOpened[idx] = data.detail.isOpen;
    });
  };
</script>

<div class="sitemap-container">
  <div>
    <Accordion
      on:toggle={onToggle.bind(null, 0)}
      open={isOpened[0]}
      enable={!isHome}>
      <div
        slot="accordion-tab"
        class="tab">
        <h4>{resources.label}</h4>
        {#if !isHome}
          <DropDownArrow
            open={isOpened[0]}
            size={20}
            color={'black'} />{/if}
      </div>
      <ul slot="accordion-content">
        {#each resources.links as link}
          <li>
            <a href={link.url}>{link.name}</a>
          </li>
        {/each}
      </ul>
    </Accordion>
  </div>
  <div>
    <Accordion
      on:toggle={onToggle.bind(null, 0)}
      open={isOpened[0]}
      enable={!isHome}>
      <div
        slot="accordion-tab"
        class="tab">
        <h4>{supports.label}</h4>
        {#if !isHome}
          <DropDownArrow
            open={isOpened[0]}
            size={20}
            color={'black'} />{/if}
      </div>
      <ul slot="accordion-content">
        {#each supports.links as link}
          <li>
            <a href={link.url}>{link.name}</a>
          </li>
        {/each}
      </ul>
    </Accordion>
  </div>
  <div>
    <Accordion
      on:toggle={onToggle.bind(null, 0)}
      open={isOpened[0]}
      enable={!isHome}>
      <div
        slot="accordion-tab"
        class="tab">
        <h4>{terms.label}</h4>
        {#if !isHome}
          <DropDownArrow
            open={isOpened[0]}
            size={20}
            color={'black'} />{/if}
      </div>
      <ul slot="accordion-content">
        {#each terms.links as link}
          <li>
            <a href={link.url}>{link.name}</a>
          </li>
        {/each}
      </ul>
    </Accordion>
  </div>
</div>

<style lang="postcss">
  .sitemap-container {
    display: flex;
    height: 100%;

    & > div {
      width: 100%;
      border-left: var(--footer-separator);
      padding-top: calc(var(--content-margin) / 2);
    }
  }

  .tab {
    position: relative;
    display: flex;
    justify-content: space-between;
    padding: 10px var(--content-margin);
    padding-block: 5px;

    img {
      width: 20px;
      transform: rotate(90deg);
      transition: transform 0.3s ease;

      &.open {
        transform: rotate(-90deg);
      }
    }
  }

  ul {
    padding: calc(var(--content-margin) / 2) var(--content-margin) var(--content-margin);
  }
</style>
